/* Virtual Reality: MList.cpp
   =============================================================================

   This file contains the functions for the MList type. The MInstr type is the
   internal representation of a list of Mips assembly instructions.

   12-12-2000 First release
*/

#include <malloc.h>
#include <stdio.h>

#include "MList.h"
#include "MInstrToString.h"

MList MList_Empty(void)
{
	return (MList)NULL;
}

MList MList_BuildNode(MInstr Instr, MList Next)
{
	MList List = (MList)malloc(sizeof(MList_Node));

	List->Instr = Instr;
	List->Next  = Next;

	return List;
}

MList MList_Add(MList List, MInstr Instr)
{
	if (List == MList_Empty())
		return MList_BuildNode(Instr, MList_Empty());

	if (List->Instr.Offset <= Instr.Offset)
		List->Next = MList_Add(List->Next, Instr);
	else
		List->Next = MList_BuildNode(Instr, List->Next);

	return List;
}

MList MList_Destroy(MList List)
{
	if (List != MList_Empty())
	{
		List->Next = MList_Destroy(List->Next);
		free(List);
	}

	return MList_Empty();
}

void MList_Print(MList List)
{
	if (List == MList_Empty())
		return;
	else
	{
		printf("%s\n", MInstr_ToString(List->Instr));
		MList_Print(List->Next);
	}
}
